Require Import connectives.
Require Import leibniz.
Require Import nat.
Parameter exp : nat.nat -> nat.nat -> nat.nat.
Parameter exp_body : nat.nat -> nat.nat -> nat.nat.
Axiom axiom_exp : forall (n:nat.nat), forall (m:nat.nat), connectives.equal (nat.nat) (exp n m) (nat.filter_nat_type (nat.nat) (exp_body n) m).
Definition eq_exp : forall (n:nat.nat), forall (m:nat.nat), leibniz.leibniz (nat.nat) (exp n m) (nat.filter_nat_type (nat.nat) (exp_body n) m) := fun (n:nat.nat) => fun (m:nat.nat) => ((((connectives.equal_leibniz) (nat.nat)) (exp n m)) (nat.filter_nat_type (nat.nat) (exp_body n) m)) (((axiom_exp) (n)) (m)).
Definition sym_eq_exp : forall (n:nat.nat), forall (m:nat.nat), leibniz.leibniz (nat.nat) (nat.filter_nat_type (nat.nat) (exp_body n) m) (exp n m) := fun (n:nat.nat) => fun (m:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat)) (exp n m)) (nat.filter_nat_type (nat.nat) (exp_body n) m)) (((eq_exp) (n)) (m)).
Axiom axiom_exp_body_O : forall (n:nat.nat), connectives.equal (nat.nat) (exp_body n nat.O) (nat.S nat.O).
Definition eq_exp_body_O : forall (n:nat.nat), leibniz.leibniz (nat.nat) (exp_body n nat.O) (nat.S nat.O) := fun (n:nat.nat) => ((((connectives.equal_leibniz) (nat.nat)) (exp_body n nat.O)) (nat.S nat.O)) ((axiom_exp_body_O) (n)).
Axiom axiom_exp_body_S : forall (n:nat.nat), forall (m:nat.nat), connectives.equal (nat.nat) (exp_body n (nat.S m)) (nat.times (exp n m) n).
Definition eq_exp_body_S : forall (n:nat.nat), forall (m:nat.nat), leibniz.leibniz (nat.nat) (exp_body n (nat.S m)) (nat.times (exp n m) n) := fun (n:nat.nat) => fun (m:nat.nat) => ((((connectives.equal_leibniz) (nat.nat)) (exp_body n (nat.S m))) (nat.times (exp n m) n)) (((axiom_exp_body_S) (n)) (m)).
Definition sym_eq_exp_body_S : forall (n:nat.nat), forall (m:nat.nat), leibniz.leibniz (nat.nat) (nat.times (exp n m) n) (exp_body n (nat.S m)) := fun (n:nat.nat) => fun (m:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat)) (exp_body n (nat.S m))) (nat.times (exp n m) n)) (((eq_exp_body_S) (n)) (m)).
